#include "EnhancedPrivacy.h"
#include <iostream>

using namespace std;

#define TEST_VECTOR 0

#if TEST_VECTOR == 0	//No test actual input
//TEST VECTOR 0
	unsigned char inputKey[] = {0x53, 0x65, 0x63};	//sec
	unsigned char input[] = {0x41, 0x74, 0x74, 0x61, 0x63, 0x6B, 0x20, 0x61, 0x74, 0x20, 0x64, 0x61, 0x77, 0x6E};	//attack at dawn
	unsigned int softwareKey = 0x726574; //ret	
	// OUTPUT should be: output = {0x9a 0x0f 0x92 0x20 0x3a 0x35 0x6d 0x2c 0xf7 0x12 0x97 0xfd 0x0e 0x12} if spin = false
    // OUTPUT should be: output = {0xf5 0x70 0x70 0x1d 0xf2 0x83 0x3f 0xf1 0x8d 0xa3 0x65 0xef 0x40 0xb6} if spin = true

#elif TEST_VECTOR == 1
//TEST VECTOR1
	unsigned char inputKey[] = {0x00, 0x00, 0x00, 0x00};
	unsigned char input[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};
	unsigned int softwareKey = 0x00000000;
	// OUTPUT should be: output = {0xde, 0x18, 0x89, 0x41, 0xa3, 0x37, 0x5d, 0x3a} if spin = false
    // OUTPUT should be: output = {0x3b, 0x3f, 0xa8, 0x3f, 0xd3, 0x55, 0xe2, 0x46} if spin = true

#elif TEST_VECTOR == 2
//TEST VECTOR2
	unsigned char inputKey[] = {0x01, 0x23, 0x45, 0x67};
	unsigned char input[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};
	unsigned int softwareKey = 0x89abcdef;
	// OUTPUT should be: output = {0x74, 0x94, 0xc2, 0xe7, 0x10, 0x4b, 0x08, 0x79} if spin = false
    // OUTPUT should be: output = {0x59, 0x5d, 0xb1, 0x08, 0x28, 0x0f, 0x2e, 0xcc} if spin = true

#elif TEST_VECTOR == 3
//TEST VECTOR3
	unsigned char inputKey[] = {0x01, 0x23, 0x45, 0x67};
	unsigned char input[] = {0x01, 0x23, 0x45, 0x67, 0x89, 0xab, 0xcd, 0xef};
	unsigned int softwareKey = 0x89abcdef;
	// OUTPUT should be: output = {0x75, 0xb7, 0x87, 0x80, 0x99, 0xe0, 0xc5, 0x96} if spin = false
    // OUTPUT should be: output = {0x58, 0x7e, 0xf4, 0x6f, 0xa1, 0xa4, 0xe3, 0x23} if spin = true

#elif TEST_VECTOR == 4
//TEST VECTOR4
	unsigned char inputKey[] = {0x00, 0xE5, 0x7B, 0x2C};
	unsigned char input[] = {0xE5, 0x7B, 0x2C};
	unsigned int softwareKey = 0xABCDEF33;
	// OUTPUT should be: output = {0xF9, 0x3B, 0xDC} if spin = false
    // OUTPUT should be: output = {0xea, 0xbb, 0xf7} if spin = true

#endif

int main()
{
	const size_t inputKeySize = sizeof(inputKey);
	const size_t inputSize = sizeof(input);
	bool spin = false;
	
	unsigned char output[inputSize];

	//Creat Object and concatenate key
	EnhancedPrivacy rc4Obj = EnhancedPrivacy(inputKey, inputKeySize, softwareKey);

	//Initialize S-Box with concatenated key
	rc4Obj.Initialize(spin);

	//Decrypt the input
	rc4Obj.EncryptionDecryption(inputSize, input, output, spin);

	return 0;
}